package bou.amine.apps.readerforselfossv2.utils

import android.net.Uri
import android.os.Build
import android.text.Html
import bou.amine.apps.readerforselfossv2.model.SelfossModel
import org.jsoup.Jsoup
import java.util.*

actual fun String.getHtmlDecoded(): String {
    return if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
        Html.fromHtml(this, Html.FROM_HTML_MODE_COMPACT).toString()
    } else {
        @Suppress("DEPRECATION")
        Html.fromHtml(this).toString()
    }
}

actual fun SelfossModel.Item.getIcon(baseUrl: String): String {
    return constructUrl(baseUrl, "favicons", icon)
}

actual fun SelfossModel.Item.getThumbnail(baseUrl: String): String {
    return constructUrl(baseUrl, "thumbnails", thumbnail)
}

actual fun SelfossModel.Item.getImages(): ArrayList<String> {
    val doc = Jsoup.parse(content)
    val images = doc.getElementsByTag("img")

    return ArrayList(images.map { it.attr("src") })
}

actual fun SelfossModel.Source.getIcon(baseUrl: String): String {
    return constructUrl(baseUrl, "favicons", icon)
}

actual fun constructUrl(baseUrl: String, path: String, file: String?): String {
    return if (file == null || file == "null" || file.isEmpty()) {
        ""
    } else {
        val baseUriBuilder = Uri.parse(baseUrl).buildUpon()
        baseUriBuilder.appendPath(path).appendPath(file)

        baseUriBuilder.toString()
    }
}