package bou.amine.apps.readerforselfossv2.utils

enum class ItemType(val position: Int, val type: String) {
    UNREAD(1, "unread"),
    ALL(2, "all"),
    STARRED(3, "starred");

    companion object {
        fun fromInt(value: Int) = values().first { it.position == value }
    }
}

enum class ImageMimeType(val extension: String, val mimeType: String) {
    JPG(".jpg", "image/jpeg"),
    JPEG(".jpeg", "image/jpeg"),
    PNG(".png", "image/png"),
    WEBP(".webp", "image/webp"),
    GIF(".gif", "image/gif"),
    SVG(".svg", "image/svg+xml"),
    BMP(".bmp", "image/bmp"),
    TIFF(".tiff", "image/tiff"),
    TIF(".tif", "image/tiff");

    companion object {
        fun findMimeTypeByExtension(ext: String) = values().find { it.extension == ext }?.mimeType
    }
}